//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ライン距離テスト実装
 * @author Junpee
 */

#include "Test/stdafx.h"
#include "Geometry/Distance/LineDistanceTest.h"

//------------------------------------------------------------------------------
// コンストラクタ
LineDistanceTest::LineDistanceTest(String name) :
	TestCase(name){
}
//------------------------------------------------------------------------------
// テストスィートの取得
Test* LineDistanceTest::suite(){
	TestSuite* suite = new TestSuite("LineDistanceTest");
	suite->addTest(new TestCaller(LineDistanceTest, testPoint));
	suite->addTest(new TestCaller(LineDistanceTest, testLine));
	suite->addTest(new TestCaller(LineDistanceTest, testOrientedBox));
	suite->addTest(new TestCaller(LineDistanceTest, testPlane));
	suite->addTest(new TestCaller(LineDistanceTest, testRay));
	suite->addTest(new TestCaller(LineDistanceTest, testSegment));
	suite->addTest(new TestCaller(LineDistanceTest, testSphere));
	suite->addTest(new TestCaller(LineDistanceTest, testTriangle));
	return suite;
}
//------------------------------------------------------------------------------
// 点テスト
void LineDistanceTest::testPoint(){
}
//------------------------------------------------------------------------------
// ラインテスト
void LineDistanceTest::testLine(){
	Line line0(0.f, 0.f, 0.f, 0.f, 1.f, 0.f);
	TestEquals(0.f, line0.getDistance(Vector3(0.f, 2.f, 0.f)));
	TestEquals(0.f, line0.getDistance(Vector3(0.f, -1.f, 0.f)));
	TestEquals(1.f, line0.getDistance(Vector3(1.f, 0.f, 0.f)));
	Line line1(0.f, 2.f, 0.f, 0.f, 1.f, 0.f);
	TestEquals(0.f, line0.getDistance(line1));
	line1.setOrigin(Vector3(1.f, 0.f, 0.f));
	TestEquals(1.f, line0.getDistance(line1));
	line1.setDirection(Vector3(1.f, 0.f, 0.f));
	TestEquals(0.f, line0.getDistance(line1));
	line1.setOrigin(Vector3(-1.f, 0.f, 0.f));
	TestEquals(0.f, line0.getDistance(line1));
}
//------------------------------------------------------------------------------
// 指向性ボックステスト
void LineDistanceTest::testOrientedBox(){
}
//------------------------------------------------------------------------------
// 平面テスト
void LineDistanceTest::testPlane(){
}
//------------------------------------------------------------------------------
// レイテスト
void LineDistanceTest::testRay(){
}
//------------------------------------------------------------------------------
// セグメントテスト
void LineDistanceTest::testSegment(){
}
//------------------------------------------------------------------------------
// 球テスト
void LineDistanceTest::testSphere(){
}
//------------------------------------------------------------------------------
// 三角テスト
void LineDistanceTest::testTriangle(){
}
//------------------------------------------------------------------------------
